# Kontaktbuch

Es soll ein Kontaktbuch erstellt werden, mit welchem man Gruppen und Kontakte verwalten kann.

### Motivation
Bei verschiedenen Systemen gibt es Benutzer und Gruppen. Diese Webseite soll dabei helfen den Überblick zu behalten.

---
Die Aufgabe besteht aus 2 Teilaufgaben

* Erstellen eines Frontends
* Erstellen eines Backends

Es ist auch möglich, dass nur eine Teilaufgabe bearbeitet wird!

**Jegliche Kommunikation zwischen Frontend und Backend soll über JSON erfolgen, falls nötig.**

## Frontend

**Das Frontend soll mittels dem JS-Framework Vue.js erstellt werden (Version 1.x).  
Für das Design soll das Framework Semantic UI verwendet werden (css reicht).  

Grundsätzlich soll JavasScript (oder TypeScript) verwendet werden. Bei TypeScript mit extenernen Bibliotheken (z.b. jQuery) kann es mit den Typen zu Problemen kommen, da die meisten Typ-Dateien im Modul-Format sind. Man kann TypeScript auch nur für eigene Typen verwenden, falls man aber eine Variable benutzt, die keinen Typ hat (z.b. $, da es ohne Typ-Datei unbekannt ist), wird das rot unterstrichen. Umgehen kann man das, indem man mittels `declare` die Variable TypeScript bekannt macht, allerdings bekommt man dann keine autovervollständigung (sofern man bei declare den typ any verwendet).

* Tipp: Bei manchen Editoren/Ides muss node.js zusätzlich installier werden, um TypeScript zu JavaScript zu übersetzen.*

*Tipp zu TypeScript und Vue.js: Das Gerüst der Komponenten zunächst in JS schreiben, dann die einzelnen Funktionen mit TypeScript "Typen" anreichern.*


Funktionen sind:

* Erstellen von Kontakten
* Bearbeiten von Kontakten
* Löschen von Kontakten
* Erstellen von Gruppen
* Bearbeiten von Gruppen
* Löschen von Gruppen
* Such nach Personen (mittels Vorname, Nachname, Email)
* Suchen nach Gruppen (mittels Name)

Die Kontakte sollten mindestens folgende Eigenschaften haben:
* Vorname
* Nachname
* Email (optional)
* Wohnort (optional)

Die Gruppen sollten mindestens folgende Eigenschaften haben:
* Name
* Beschreibung (optional)
* Email (optional)

Zu beachten gilt, dass eine Person in mehreren Gruppen sein kann. Natürlich kann es in einer 
Gruppe mehrere Personen geben.

Als Editor empfiehlt sich hier WebStorm/IntelliJ Ultimate (diese haben einen TypeScript Kompiler dabei).

## Backend

Das backend soll mittels Asp.net Core erstellt werden. Da es bei Asp.net Core gerade umstrukturierungen gibt, soll das vorhandene Projekt als Vorgabe benutzt werden.

Das Backend soll zudem Daten ausschließlich in JSON zurückgeben. D.h. die MVC Fähigkeiten von Asp.net Core sollen nicht benutzt werden.

Ähnlich der Todo-Liste-Aufgabe, soll das Backend alle nötigen Funktionen unterstützen. 
Mindestens sollte jedoch folgendes möglich sein:

 Erstellen von Kontakten
* Bearbeiten von Kontakten
* Löschen von Kontakten
* Erstellen von Gruppen
* Bearbeiten von Gruppen
* Löschen von Gruppen
* Such nach Personen (mittels Vorname, Nachname, Email)
* Suchen nach Gruppen (mittels Name)

Das Speichern der Daten kann mittels eine Klasse/Variable erfolgen, d.h. es muss keine Persistente Speicherung erfolgen.

Es ist natürlich auch möglich, dass man das EntityFramework Core benutzt und den InMemory-Provider. Eine Anbindung an eine echte Datenbank ist natürlich auch möglich.
Hierzu sei gesagt, dass beim EntityFramework die Konfiguration relativ schwierig werden kann...

Als Editor ist hier für Windows Visual Studio (z.B. Community-Edition ab 2015) geeignet. Für andere Betriebssysteme ist Visual Studio Code zu empfehlen (gibt es natürlich auch für Windows).

Falls die Konfiguration mit Visual Studio Code nich automatisch eingerichtet wird (links der Käfer und auf den grünen Pfeil), dann sollte man das Projekt nicht an der Wurzel öffnen **AspTest/** sondern den tieferen Ordner **AspTest/src/AspTest** und erneut Konfigurieren (links der Käfer und auf den grünen Pfeil).

Für die .net Core Version (welches installiert werden muss) sollte 1.x verwendet werden (bzw. 1.0.0-preview2-003156 funktioniert sicher).