# Studio Ghibli

Es soll eine Todo-Liste erstellt werden, um Aufgaben zu verwalten.

### Motivation
Studio Ghibli hat einige Filme herausgebracht. Dabei kann man leicht den Überblick verlieren und Fakten vergessen. Wenn man sich fragt, ob man alle Filme gesehen hat, ist das ebenfalls nicht leicht/schnell festzustellen...  
Möchte man mehr über einen Film erfahren, muss man sich den Artikel auf Wikipedia angucken, was relativ langweilig ist (da nicht interaktiv).
Zum glück gibt es dafür Programme/Webseiten!

Unter https://ghibliapi.herokuapp.com existiert eine frei zugängliche Api, mit der man an die gewünschten Informationen kommen kann. Die Informationen werden per JSON übertragen.

---

Die Aufgabe besteht aus 1 Teilaufgabe.

* Erstellen eines Frontends


## Frontend

**Das Frontend soll mittels dem JS-Framework Vue.js erstellt werden (Version 1.x).  
Für das Design soll das Framework Semantic UI verwendet werden (css reicht).  

Grundsätzlich soll JavasScript (oder TypeScript) verwendet werden. Bei TypeScript mit extenernen Bibliotheken (z.b. jQuery) kann es mit den Typen zu Problemen kommen, da die meisten Typ-Dateien im Modul-Format sind. Man kann TypeScript auch nur für eigene Typen verwenden, falls man aber eine Variable benutzt, die keinen Typ hat (z.b. $, da es ohne Typ-Datei unbekannt ist), wird das rot unterstrichen. Umgehen kann man das, indem man mittels `declare` die Variable TypeScript bekannt macht, allerdings bekommt man dann keine autovervollständigung (sofern man bei declare den typ any verwendet).

* Tipp: Bei manchen Editoren/Ides muss node.js zusätzlich installier werden, um TypeScript zu JavaScript zu übersetzen.*

*Tipp zu TypeScript und Vue.js: Das Gerüst der Komponenten zunächst in JS schreiben, dann die einzelnen Funktionen mit TypeScript "Typen" anreichern.*

Im Frontend soll es möglich sein, dass man alle

* Filme
* Personen
* Orte

anzeigen kann.  
Die dargestellen Informationen sollen mindestens folgendes umfassen:

* Filme
  * Titel
  * Beschreibung
  * Regisseur
  * Produzent
  * Welche Personen in diesem Film mitgespielt haben
  * Welche Orte hier vorkommen
* Personen
  * Name
  * Geschlecht
  * Augenfarbe
  * Haarfarbe
  * Bei welchen Filmen diese Person mitgespielt hat
* Orte
  * Name
  * Klimazone
  * Terrain
  * Welche Personen hier leben
  * In welchen Filmen der Ort vorkommt


Außerdem soll es möglich sein, dass man die Filme nach Regisseur oder Produzent filtern kann.
Dabei sollen die Eingaben nicht freitext sein, sondern man soll nur existierende Regisseure und Produzent "eingeben können". Die Eigabe *könnte* z.B. mit Autovervollständigung, einem Select oder mittels Buttons erfolgen. Andere Möglichkeiten sind auch gern gesehen.

Das Filtern nach anderen Eigenschaften der Personen und Ort kann ausgelassen werden, da dies analog funktioniert ;).

Die letzte Anforderung ist, dass man zu jedem Film angeben können soll, ob man diesen bereits gesehen hat oder nicht. Außerdem soll man eine Wertung zwischen 0 und 5 vergeben können.
Die Daten sollen nur temporär für die aktuelle Sitzung gespeichert werden (z.B. in einer Variable).

Die genaue Darstellung der aller Informationen kann beliebig realisiert werden (Semantic UI bietet dabei ein paar nette css Klassen).

Als Editor empfiehlt sich hier WebStorm/IntelliJ Ultimate (diese haben einen TypeScript Kompiler dabei).